Xapian::ValueMapPostingSource Class Reference

A posting source which looks up weights in a map using values as the key. More...

`#include <postingsource.h>`

Inheritance diagram for Xapian::ValueMapPostingSource:
[legend]

## Public Member Functions

| ValueMapPostingSource (Xapian::valueno slot_)
| Construct a ValueMapPostingSource.
void | add_mapping (const std::string &key, double wt)
| Add a mapping.
void | clear_mappings ()
| Clear all mappings.
void | set_default_weight (double wt)
| Set a default weight for document values not in the map.
double | get_weight () const
| Return the weight contribution for the current document.
ValueMapPostingSource * | clone () const
| Clone the posting source.
std::string | name () const
| Name of the posting source class.
std::string | serialise () const
| Serialise object parameters into a string.
ValueMapPostingSource * | unserialise (const std::string &serialised) const
| Create object given string serialisation returned by serialise().
void | init (const Database &db_)
| Set this PostingSource to the start of the list of postings.
std::string | get_description () const
| Return a string describing this object.
Public Member Functions inherited from Xapian::ValuePostingSource
| ValuePostingSource (Xapian::valueno slot_)
| Construct a ValuePostingSource.
Xapian::doccount | get_termfreq_min () const
| A lower bound on the number of documents this object can return.
Xapian::doccount | get_termfreq_est () const
| An estimate of the number of documents this object can return.
Xapian::doccount | get_termfreq_max () const
| An upper bound on the number of documents this object can return.
void | next (double min_wt)
| Advance the current position to the next matching document.
void | skip_to (Xapian::docid min_docid, double min_wt)
| Advance to the specified docid.
bool | check (Xapian::docid min_docid, double min_wt)
| Check if the specified docid occurs.
bool | at_end () const
| Return true if the current position is past the last entry in this list.
Xapian::docid | get_docid () const
| Return the current docid.
void | init (const Database &db_)
| Set this PostingSource to the start of the list of postings.
Xapian::Database | get_database () const
| The database we're reading values from.
Xapian::valueno | get_slot () const
| The slot we're reading values from.
std::string | get_value () const
| Read current value.
void | done ()
| End the iteration.
bool | get_started () const
| Flag indicating if we've started (true if we have).
void | set_termfreq_min (Xapian::doccount termfreq_min_)
| Set a lower bound on the term frequency.
void | set_termfreq_est (Xapian::doccount termfreq_est_)
| An estimate of the term frequency.
void | set_termfreq_max (Xapian::doccount termfreq_max_)
| An upper bound on the term frequency.
Public Member Functions inherited from Xapian::PostingSource
| PostingSource ()
| Allow subclasses to be instantiated.
void | set_maxweight (double max_weight)
| Specify an upper bound on what get_weight() will return from now on.
double | get_maxweight () const
| Return the currently set upper bound on what get_weight() can return.
virtual PostingSource * | unserialise_with_registry (const std::string &serialised, const Registry &registry) const
| Create object given string serialisation returned by serialise().
PostingSource * | release ()
| Start reference counting this object.
const PostingSource * | release () const
| Start reference counting this object.

## Additional Inherited Members

Protected Attributes inherited from Xapian::ValuePostingSource
Xapian::Database & | db
| The database we're reading values from.
Xapian::valueno & | slot
| The slot we're reading values from.
Xapian::ValueIterator & | value_it
| Value stream iterator.
bool & | started
| Flag indicating if we've started (true if we have).
Xapian::doccount & | termfreq_min
| A lower bound on the term frequency.
Xapian::doccount & | termfreq_est
| An estimate of the term frequency.
Xapian::doccount & | termfreq_max
| An upper bound on the term frequency.

## Detailed Description

A posting source which looks up weights in a map using values as the key.

This allows will return entries for all documents in the given database which have a value in the slot specified. The values will be mapped to the corresponding weight in the weight map. If there is no mapping for a particular value, the default weight will be returned (which itself defaults to 0.0).

## Constructor & Destructor Documentation

## ValueMapPostingSource()

Xapian::ValueMapPostingSource::ValueMapPostingSource | ( | Xapian::valueno | slot_ | ) |

explicit

Construct a ValueMapPostingSource.

Parameters

  slot_ | The value slot to read values from.

## Member Function Documentation

## add_mapping()

void Xapian::ValueMapPostingSource::add_mapping | ( | const std::string & | key,
|  | double | wt
| ) |  |

Add a mapping.

Parameters

  key | The key looked up from the value slot.
  wt | The weight to give this key.

## clone()

ValueMapPostingSource * Xapian::ValueMapPostingSource::clone | ( |  | ) | const

virtual

Clone the posting source.

The clone should inherit the configuration of the parent, but need not inherit the state. ie, the clone does not need to be in the same iteration position as the original: the matcher will always call init() on the clone before attempting to move the iterator, or read the information about the current position of the iterator.

This may return NULL to indicate that cloning is not supported. In this case, the PostingSource may only be used with a single-database search.

The default implementation returns NULL.

Note that the returned object will be deallocated by Xapian after use with "delete". If you want to handle the deletion in a special way (for example when wrapping the Xapian API for use from another language) then you can define a static `operator delete` method in your subclass as shown here: https://trac.xapian.org/ticket/554#comment:1

Reimplemented from Xapian::PostingSource.

## get_description()

std::string Xapian::ValueMapPostingSource::get_description | ( |  | ) | const

virtual

Return a string describing this object.

This default implementation returns a generic answer. This default it provided to avoid forcing those deriving their own PostingSource subclass from having to implement this (they may not care what get_description() gives for their subclass).

Reimplemented from Xapian::PostingSource.

## get_weight()

double Xapian::ValueMapPostingSource::get_weight | ( |  | ) | const

virtual

Return the weight contribution for the current document.

This default implementation always returns 0, for convenience when implementing "weight-less" PostingSource subclasses.

This method may assume that it will only be called when there is a "current document". In detail: Xapian will always call init() on a PostingSource before calling this for the first time. It will also only call this if the PostingSource reports that it is pointing to a valid document (ie, it will not call it before calling at least one of next(), skip_to() or check(), and will ensure that the PostingSource is not at the end by calling at_end()).

Reimplemented from Xapian::PostingSource.

## init()

void Xapian::ValueMapPostingSource::init | ( | const Database & | db | ) |

virtual

Set this PostingSource to the start of the list of postings.

This is called automatically by the matcher prior to each query being processed.

If a PostingSource is used for multiple searches, init() will therefore be called multiple times, and must handle this by using the database passed in the most recent call.

Parameters

  db | The database which the PostingSource should iterate through.

Note: in the case of a multi-database search, a separate PostingSource will be used for each database (the separate PostingSources will be obtained using clone()), and each PostingSource will be passed one of the sub-databases as the db parameter here. The db parameter will therefore always refer to a single database. All docids passed to, or returned from, the PostingSource refer to docids in that single database, rather than in the multi-database.

Implements Xapian::PostingSource.

## name()

std::string Xapian::ValueMapPostingSource::name | ( |  | ) | const

virtual

Name of the posting source class.

This is used when serialising and unserialising posting sources; for example, for performing remote searches.

If the subclass is in a C++ namespace, the namespace should be included in the name, using "::" as a separator. For example, for a PostingSource subclass called "FooPostingSource" in the "Xapian" namespace the result of this call should be "Xapian::FooPostingSource".

This should only be implemented if serialise() and unserialise() are also implemented. The default implementation returns an empty string.

If this returns an empty string, Xapian will assume that serialise() and unserialise() are not implemented.

Reimplemented from Xapian::PostingSource.

## serialise()

std::string Xapian::ValueMapPostingSource::serialise | ( |  | ) | const

virtual

Serialise object parameters into a string.

The serialised parameters should represent the configuration of the posting source, but need not (indeed, should not) represent the current iteration state.

If you don't want to support the remote backend, you can use the default implementation which simply throws Xapian::UnimplementedError.

Reimplemented from Xapian::PostingSource.

## set_default_weight()

void Xapian::ValueMapPostingSource::set_default_weight | ( | double | wt | ) |

Set a default weight for document values not in the map.

Parameters

  wt | The weight to set as the default.

## unserialise()

ValueMapPostingSource * Xapian::ValueMapPostingSource::unserialise | ( | const std::string & | serialised | ) | const

virtual

Create object given string serialisation returned by serialise().

Note that the returned object will be deallocated by Xapian after use with "delete". If you want to handle the deletion in a special way (for example when wrapping the Xapian API for use from another language) then you can define a static `operator delete` method in your subclass as shown here: https://trac.xapian.org/ticket/554#comment:1

If you don't want to support the remote backend, you can use the default implementation which simply throws Xapian::UnimplementedError.

Parameters

  serialised | A serialised instance of this PostingSource subclass.

Reimplemented from Xapian::PostingSource.

The documentation for this class was generated from the following file:

- xapian/postingsource.h